/*
 * Created on Sep 12, 2004
 */
package org.tekkotsu.ui.editor.model.commands;

import java.util.Iterator;
import java.util.List;

import org.eclipse.gef.commands.Command;
import org.tekkotsu.ui.editor.model.AbstractConnectionModel;
import org.tekkotsu.ui.editor.model.AbstractModel;
import org.tekkotsu.ui.editor.model.MultiTransitionModel;
import org.tekkotsu.ui.editor.model.StateNodeModel;
import org.tekkotsu.ui.editor.model.LayoutData;

/**
 * @author asangpet
 */

public class DeleteCommand extends Command {
	private LayoutData contentsModel;
	private StateNodeModel stateNodeModel;
	private List<AbstractConnectionModel> sourceConnections;
	private List<AbstractConnectionModel> targetConnections;
	
	public static void delete(LayoutData ld, AbstractModel child)
	{
		child.doPreDelete(ld);
		ld.removeChild(child);
	}
	
	@Override
	public void execute() {
		delete(contentsModel,stateNodeModel);
	}
	
	public void setContentsModel(Object model) {
		contentsModel = (LayoutData) model;		
	}
	
	public void setStateNodeModel(Object model) {
		stateNodeModel = (StateNodeModel) model;
	}
	
	@Override
	public void undo() {
		contentsModel.addChild(stateNodeModel);

		if (stateNodeModel instanceof MultiTransitionModel) {
			((MultiTransitionModel)stateNodeModel).doPostAdd();
		} else {
			for (Iterator<AbstractConnectionModel> iter = sourceConnections.iterator(); iter.hasNext();) {
				AbstractConnectionModel model = iter.next();
				model.attachSource();
				model.attachTarget();
			}

			for (Iterator<AbstractConnectionModel> iter = targetConnections.iterator(); iter.hasNext();) {
				AbstractConnectionModel model = iter.next();
				model.attachSource();
				model.attachTarget();
			}
		
			sourceConnections.clear();
			targetConnections.clear();
		}
	}
}
