package org.tekkotsu.ui.settings;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import org.tekkotsu.ui.util.Debugger;
import org.tekkotsu.ui.util.FilesystemUtil;

public class SettingsFile
{
	public static final String SETTINGS_PATH = ".tekkotsu_settings/";
	public static final String SETTINGS_FILE = SETTINGS_PATH + "settings.ini";
	
	public static void loadSettings()
	{
		try {
			String file = "";
			File settingsFile = new File(SETTINGS_FILE).getAbsoluteFile();
			FileInputStream fin = new FileInputStream(settingsFile);
			BufferedReader myInput = new BufferedReader(new InputStreamReader(fin));
			String thisLine;
		    StringBuffer strb = new StringBuffer("") ;
			while ((thisLine = myInput.readLine()) != null) {  
	              strb.append(thisLine+"\r\n");
            }
			file = strb.toString();
		
			//now file is the contents of the file
			String[] lines = file.split("\n");
			
			for( String line : lines )
			{
				line = line.trim();
				
				String[] parts = line.split("=");
				if(parts.length != 2)
					continue;
				if(parts[0].equals("stickypath"))
				{
					FilesystemUtil.stickyPathSet(parts[1]);
				}
			}
		} catch (FileNotFoundException e) {
			Debugger.printThrowable(e);
		} catch (IOException e) {
			Debugger.printThrowable(e);
		}
	}
	
	public static void saveSettings()
	{
		try{
			File settingsPath = new File(SETTINGS_PATH).getAbsoluteFile();
			settingsPath.mkdirs();
		
			File settingsFile = new File(SETTINGS_FILE).getAbsoluteFile();
		
			if(!settingsFile.exists())
			{
				settingsFile.createNewFile();
			}
			FileOutputStream fout = new FileOutputStream(settingsFile);
			BufferedWriter out = new BufferedWriter(new OutputStreamWriter(fout));
			out.append("stickypath=" + FilesystemUtil.stickyPathGet() + "\n");
			out.flush();
		} catch (FileNotFoundException e) {
			Debugger.printThrowable(e);
		} catch (IOException e) {
			Debugger.printThrowable(e);
		}
	}
}
