/*
 * Created on Nov 11, 2004
 */
package org.tekkotsu.ui.storyboard.model;

import org.tekkotsu.ui.storyboard.views.RuntimeView;
import org.tekkotsu.ui.storyboard.views.RuntimeView.TreeObject;
import org.tekkotsu.ui.storyboard.views.RuntimeView.TreeParent;

import static org.tekkotsu.ui.storyboard.views.RuntimeView.timeToString;

/**
 * @author asangpet
 */
public class BlockModel extends AbstractModel {
	public BlockModel(int rawstart, int rawend, String id, int start, int end,
			boolean finish) {
		super(rawstart, rawend, id, start, end, finish);
	}

	public BlockModel(int rawstart, String id, int start) {
		this(rawstart, UNKNOWN_TIME, id, start, UNKNOWN_TIME, false);
	}

	@Override
	public RuntimeView.TreeObject getRuntimeViewData() {
		TreeParent par;

		par = new TreeParent(getID(), getRawStart(), getRawEnd());

		par.addChild(new TreeObject("type: state"));
		par.addChild(new TreeObject("activate at: "
				+ timeToString(getRawStart())));

		par.addChild(new TreeObject("deactivate at: "
				+ timeToString(getRawEnd())));
		return par;
	}
}
